#ifdef GL_ES
precision mediump float;
#endif

uniform vec3 u_color;
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;

vec4 getInputColor()
{
    return texture2D(u_texture, v_texCoord);
}

vec3 toGrayscale(in vec3 color)
{
	float average = (color.r + color.g + color.b) / 3.0;
	return vec3(average, average, average);
}

vec3 colorize(in vec3 grayscale, in vec3 color)
{
    return (grayscale * color);
}

void main()
{
	// The input fragment color.
	vec4 inputColor = getInputColor();

	vec3 c = u_color;

	// Convert to grayscale first:
	vec3 grayscale = toGrayscale(inputColor.rgb);

	// Then "colorize" by simply multiplying the grayscale with the desired color.
	vec3 colorizedOutput = colorize(grayscale, c);

	gl_FragColor = vec4(colorizedOutput, inputColor.a);
	//gl_FragColor = v_fragmentColor * vec4(colorizedOutput, inputColor.a);
}
